diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.c b/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.c
index 8a2ab7e..660514c 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.c
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.c
@@ -1067,44 +1084,71 @@ BalloonMonitorGetTarget(Balloon *b,     // IN
  */
 
 static int
-BalloonMonitorLockPage(Balloon *b,        // IN
-                        PageHandle handle) // IN
+BalloonDeflate(Balloon *b,      // IN
+               uint32 target)   // IN
 {
-   unsigned long ppn;
-   uint32 ppn32;
-   uint32 status, target;
-   Backdoor_proto bp;
+   int                  status = BALLOON_SUCCESS;
+   uint32               goal, nPages;
+   BalloonChunk         *chunk = NULL;
 
-   ppn = OS_ReservedPageGetPPN(handle);
+   goal = b->nPages - target;
 
-   /* Ensure PPN fits in 32-bits, i.e. guest memory is limited to 16TB. */
-   ppn32 = (uint32)ppn;
-   if (ppn32 != ppn) {
-      return BALLOON_ERROR_PPN_INVALID;
-   }
+   /* limit deallocation rate */
+   goal = MIN(goal, b->rateFree);
 
-   /* prepare backdoor args */
-   bp.in.cx.halfs.low = BALLOON_BDOOR_CMD_LOCK;
-   bp.in.size = ppn32;
+   nPages = 0;
+   for ( ; goal > 0; goal--) {
+      PageHandle lockedHandle;
 
-   /* invoke backdoor */
-   Backdoor_Balloon(&bp);
+      if (chunk == NULL) {
+         if (!DblLnkLst_IsLinked(&b->chunks)) {
+            /* The chunk list is empty, the balloon cannot be deflated */
+            status = BALLOON_FAILURE;
+            goto out;
+         }
 
-   /* parse return values */
-   status = bp.out.ax.word;
-   target = bp.out.bx.word;
+         chunk = DblLnkLst_Container(b->chunks.next, BalloonChunk, node);
+      }
+
+      lockedHandle = chunk->page[--chunk->pageCount];
+      if (!chunk->pageCount) {
+         DblLnkLst_Unlink1(&chunk->node);
+         /*
+          * Do not free the chunk, we may need it if the UNLOCK cmd fails
+          */
+         b->fallbackChunk = chunk;
 
-   /* set flag if reset requested */
-   if (status == BALLOON_ERROR_RESET) {
-      b->resetFlag = 1;
+         b->nChunks--;
+         chunk = NULL;
    }
 
-   /* update stats */
-   STATS_INC(b->stats.lock);
+      b->balloonOps->addPage(b, nPages++, lockedHandle);
+      if (nPages == b->batchMaxPages) {
+         status = b->balloonOps->unlock(b, nPages);
+         nPages = 0;
+
    if (status != BALLOON_SUCCESS) {
-      STATS_INC(b->stats.lockFail);
+            if (BALLOON_RATE_ADAPT) {
+               /* quickly decrease rate if error */
+               b->rateFree = MAX(b->rateFree / 2, BALLOON_RATE_FREE_MIN);
+            }
+            goto out;
+         }
+
+      }
    }
 
+   if (nPages) {
+      status = b->balloonOps->unlock(b, nPages);
+   }
+
+   if (status == BALLOON_SUCCESS && BALLOON_RATE_ADAPT) {
+      /* slowly increase rate if no errors */
+      b->rateFree = MIN(b->rateFree + BALLOON_RATE_FREE_INC,
+                        BALLOON_RATE_FREE_MAX);
+   }
+
+out:
    return status;
 }
 
@@ -1112,10 +1156,10 @@ BalloonMonitorLockPage(Balloon *b,        // IN
 /*
  *----------------------------------------------------------------------
  *
- * BalloonMonitorUnlockPage --
+ * BalloonAdjustSize --
  *
- *      Attempts to contact monitor and remove PPN corresponding to
- *      the page handle from set of "balloon locked" pages.
+ *      Attempts to allocate or deallocate physical pages in order
+ *      to reach desired "target" size for balloon "b".
  *
  * Results:
  *      Returns BALLOON_SUCCESS if successful, otherwise error code.
@@ -1127,54 +1171,25 @@ BalloonMonitorLockPage(Balloon *b,        // IN
  */
 
 static int
-BalloonMonitorUnlockPage(Balloon *b,        // IN
-                          PageHandle handle) // IN
+BalloonAdjustSize(Balloon *b,    // IN
+                  uint32 target) // IN
 {
-   unsigned long ppn;
-   uint32 ppn32;
-   uint32 status, target;
-   Backdoor_proto bp;
-
-   ppn = OS_ReservedPageGetPPN(handle);
-
-   /* Ensure PPN fits in 32-bits, i.e. guest memory is limited to 16TB. */
-   ppn32 = (uint32)ppn;
-   if (ppn32 != ppn) {
-      return BALLOON_ERROR_PPN_INVALID;
-   }
-
-   /* prepare backdoor args */
-   bp.in.cx.halfs.low = BALLOON_BDOOR_CMD_UNLOCK;
-   bp.in.size = ppn32;
-
-   /* invoke backdoor */
-   Backdoor_Balloon(&bp);
-
-   /* parse return values */
-   status = bp.out.ax.word;
-   target = bp.out.bx.word;
-
-   /* set flag if reset requested */
-   if (status == BALLOON_ERROR_RESET) {
-      b->resetFlag = 1;
-   }
-
-   /* update stats */
-   STATS_INC(b->stats.unlock);
-   if (status != BALLOON_SUCCESS) {
-      STATS_INC(b->stats.unlockFail);
+   if (b->nPages < target) {
+      return BalloonInflate(b, target);
+   } else if (b->nPages > target) {
+      return BalloonDeflate(b, target);
+   } else {
+      /* already at target */
+      return BALLOON_SUCCESS;
    }
-
-   return status;
 }
 
-
 /*
  *----------------------------------------------------------------------
  *
  * Balloon_Init --
  *
- *      Initializes state oif the balloon.
+ *      Initializes state of the balloon.
  *
  * Results:
  *      Returns TRUE on success (always).
@@ -1201,6 +1216,12 @@ Balloon_Init(BalloonGuest guestType)
    /* initialize reset flag */
    b->resetFlag = TRUE;
 
+   b->hypervisorCapabilities = 0;
+
+   b->pageHandle = PAGE_HANDLE_INVALID;
+   b->batchPageMapping = MAPPING_INVALID;
+   b->batchPage = NULL;
+
    return TRUE;
 }
 
@@ -1231,7 +1252,7 @@ Balloon_Cleanup(void)
     * Reset connection before deallocating memory to avoid potential for
     * additional spurious resets from guest touching deallocated pages.
     */
-   BalloonMonitorStart(b);
+   Backdoor_MonitorStart(b, BALLOON_CAPABILITIES);
    Balloon_Deallocate(b);
 }
 
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.h b/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.h
index 5b7ab37..f814b30 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.h
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.h
@@ -1,5 +1,5 @@
 /*********************************************************
- * Copyright (C) 2000 VMware, Inc. All rights reserved.
+ * Copyright (C) 2000-2012 VMware, Inc. All rights reserved.
  *
  * This program is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by the
@@ -23,12 +23,10 @@
 #ifndef	VMBALLOON_H
 #define	VMBALLOON_H
 
+#include "balloonInt.h"
 #include "vm_basic_types.h"
-
-#define BALLOON_NAME                    "vmmemctl"
-#define BALLOON_NAME_VERBOSE            "VMware memory control driver"
-
-#define BALLOON_POLL_PERIOD             1 /* sec */
+#include "dbllnklst.h"
+#include "os.h"
 
 /*
  * Page allocation flags
@@ -76,6 +74,71 @@ typedef struct {
    uint32 guestTypeFail;
 } BalloonStats;
 
+#define BALLOON_ERROR_PAGES             16
+
+typedef struct {
+   PageHandle page[BALLOON_ERROR_PAGES];
+   uint32 pageCount;
+} BalloonErrorPages;
+
+#define BALLOON_CHUNK_PAGES             1000
+
+typedef struct BalloonChunk {
+   PageHandle page[BALLOON_CHUNK_PAGES];
+   uint32 pageCount;
+   DblLnkLst_Links node;
+} BalloonChunk;
+
+struct BalloonOps;
+
+typedef struct {
+   /* sets of reserved physical pages */
+   DblLnkLst_Links chunks;
+   int nChunks;
+
+   /* transient list of non-balloonable pages */
+   BalloonErrorPages errors;
+
+   BalloonGuest guestType;
+
+   /* balloon size */
+   int nPages;
+   int nPagesTarget;
+
+   /* reset flag */
+   int resetFlag;
+
+   /* adjustment rates (pages per second) */
+   int rateAlloc;
+   int rateFree;
+
+   /* slowdown page allocations for next few cycles */
+   int slowPageAllocationCycles;
+
+   /* statistics */
+   BalloonStats stats;
+
+   /* hypervisor exposed capabilities */
+   BalloonCapabilities hypervisorCapabilities;
+
+   /* balloon operations, tied to the capabilities */
+   const struct BalloonOps *balloonOps;
+
+   /* Either the batch page handle, or the page to lock on v2 */
+   PageHandle pageHandle;
+   Mapping batchPageMapping;
+   BalloonBatchPage *batchPage;
+   uint16 batchMaxPages;
+
+   BalloonChunk *fallbackChunk;
+} Balloon;
+
+typedef struct BalloonOps {
+   void (*addPage)(Balloon *b, uint16 idx, PageHandle page);
+   int (*lock)(Balloon *b, uint16 nPages);
+   int (*unlock)(Balloon *b, uint16 nPages);
+} BalloonOps;
+
 /*
  * Operations
  */
-- 
2.0.1

